#include "mpi.h"
#include <stdio.h>

#define NPROCS 8

int main(int argc, char *argv[]) {
    int rank, new_rank, send_buf, recv_buf, num_tasks,
            ranks1[4] = {0, 1, 2, 3}, ranks2[4] = {4, 5, 6, 7};
    MPI_Group orig_group, new_group;   // required variables
    MPI_Comm new_comm;   // required variable

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &num_tasks);


    send_buf = rank;

    // Extract the original group handle
    MPI_Comm_group(MPI_COMM_WORLD, &orig_group);

    // Divide tasks into two distinct groups based upon rank
    if (rank < NPROCS / 2) {
        MPI_Group_incl(orig_group, NPROCS / 2, ranks1, &new_group);
    } else {
        MPI_Group_incl(orig_group, NPROCS / 2, ranks2, &new_group);
    }

    // Creates new communicator and then perform collective communications
    MPI_Comm_create(MPI_COMM_WORLD, new_group, &new_comm);
    MPI_Allreduce(&send_buf, &recv_buf, 1, MPI_INT, MPI_SUM, new_comm);

    // Get rank in new group
    MPI_Group_rank(new_group, &new_rank);
    printf("rank= %d new_rank= %d recv_buf= %d\n", rank, new_rank, recv_buf);

    MPI_Finalize();
    return 0;
}